import java.awt.*;
import java.applet.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
public class ControlPoint implements java.io.Serializable{
  Point3d point=null;
  Point3d n1;
  Point3d n2;
  
  int MID;
  
  int ID=-1;
  double [] wij;
  double alpha=2.0;
  double epsilon=0.3;
  ControlPoint next=null;
  ControlPoint back=null;
  
  public ControlPoint getObj(){
    return this;
  }
  public ControlPoint(){
    point = new Point3d(0.0,0.0,0.0);
    n1 = new Point3d(1.0,0.0,0.0);
    n2 = new Point3d(0.0,1.0,0.0);
    
    ID=MID=-1;
  }
  
  public ControlPoint(int dID,double dx,double dy,double dz,int dMID,int numberV){
    point = new Point3d(dx,dy,dz);
    ID = dID;
    MID = dMID;
    n1 = new Point3d(1.0,0.0,0.0);
    n2 = new Point3d(0.0,1.0,0.0);
    
    wij = new double[numberV];

   }
   public ControlPoint(int dID,double dx,double dy,double dz,int dMID){
    point = new Point3d(dx,dy,dz);
    ID = dID;
    MID = dMID;
    n1 = new Point3d(1.0,0.0,0.0);
    n2 = new Point3d(0.0,1.0,0.0);
   }
  
   
}


