import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.geometry.*;
    public class PickObjectTransform {
      public TransformGroup objTrans;
      public TransformGroup ddobjTrans;
      
      private BranchGroup bg=null;
      private SharedGroup sg=null;
      Appearance app;
      Material m;
      Vector3d mytransition = new Vector3d(0.0,0.0,0.0);
	TransparencyAttributes tattr;
      TransformGroup mytrans;
      PolygonAttributes pa;
      Color3f eColor = new Color3f(0.0f, 0.0f, 0.0f);
      Color3f sColor = new Color3f(1.0f, 1.0f, 1.0f);
      Color3f normalc;
      Sphere mypoint;   
      int ccheck=1;
      public void setPosition(Point3d dv,double scale){
	Transform3D trns = new Transform3D();
	trns.setTranslation(new Vector3d(dv.x*scale,dv.y*scale,dv.z*scale));
	objTrans.setTransform(trns);
      }
      public void setPosition(int targetI,Point3d dv,double scale){
	Transform3D trns = new Transform3D();
	trns.setTranslation(new Vector3d(dv.x*scale,dv.y*scale,dv.z*scale));
	((TransformGroup)objTrans.getChild((targetI))).setTransform(trns);
      }
      
      /*
      public void movePosition(ControlPoint targetI,Point3d dv,Ngon myn){
	int i=0;
	
	Transform3D trns = new Transform3D();
	ControlPoint now=myn.CHead;
	while(now.next!=myn.CTail){
	  now = now.next;
	  if(now.ID!=targetI.ID){
	  mytransition.x = now.rp.x + dv.x;
	  mytransition.y = now.rp.y + dv.y;
	  mytransition.z = now.rp.z + dv.z;
	  trns.setTranslation(mytransition);
	  now.rp.x += dv.x;
	  now.rp.y += dv.y;
	  now.rp.z += dv.z;
	  myn.changeCPIPpoint(now,now.rp);
	  ((TransformGroup)objTrans.getChild((now.ID))).setTransform(trns);
	  }
	}
		
      }
      */
      
      public void changeSR(float dv){
	  	if(sg!=null){
	  
	  
	  mypoint = new Sphere(dv,Sphere.GENERATE_NORMALS|Sphere.ENABLE_GEOMETRY_PICKING,15);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	  mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
	mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	
	  mypoint.setAppearance(app);
	  sg.setChild(mypoint,0);
	  
	}else{
	  
	  //int myId = ((Integer)(mypoint.getUserData())).intValue(); 
	
	ControlPoint myId = ((PickInfo)(mypoint.getUserData())).pickCP;
	  mypoint = new Sphere(dv,Sphere.GENERATE_NORMALS|Sphere.ENABLE_GEOMETRY_PICKING,15);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	  mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
	mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	
	  mypoint.setAppearance(app);
	  
	  //mypoint.setUserData(new Integer(myId));
	  mypoint.setUserData(new PickInfo(myId,ccheck));
	  objTrans.setChild(mypoint,0);
	
	  }
      }


      public PickObjectTransform(float Sphereradius,
				 TransformGroup dobjTrans,
				 
				 int dccheck){
	
	ddobjTrans = dobjTrans;
	mypoint = new Sphere(Sphereradius,Sphere.GENERATE_NORMALS|Sphere.ENABLE_GEOMETRY_PICKING,15);
	//mypoint.setUserData(new PickInfo(-1,dccheck));
	mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
	mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	
	ccheck = dccheck;
	if(ccheck==0){
	  normalc = new Color3f(1.0f,1.0f,0.0f);
	}else if(ccheck==1){
	  normalc = new Color3f(1.0f,0.0f,0.0f);
	}else{
	  normalc = new Color3f(0.0f,1.0f,0.0f);
	}
        objTrans = new TransformGroup();
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
	objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
	app = new Appearance();
	app.setCapability(app.ALLOW_POINT_ATTRIBUTES_WRITE);
	app.setCapability(app.ALLOW_POLYGON_ATTRIBUTES_WRITE);
	app.setCapability(app.ALLOW_MATERIAL_WRITE);
	app.setCapability(app.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
	
	tattr = new TransparencyAttributes(TransparencyAttributes.BLENDED,0.6f);
	tattr.setCapability(TransparencyAttributes.ALLOW_VALUE_READ); 
	tattr.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
	tattr.setTransparencyMode(TransparencyAttributes.BLENDED);
	
	app.setTransparencyAttributes(tattr);
	app.setTransparencyAttributes(null);
	
	pa = new PolygonAttributes();
	pa.setCapability(pa.ALLOW_MODE_WRITE);
	pa.setCapability(pa.ALLOW_NORMAL_FLIP_WRITE);
	pa.setCapability(pa.ALLOW_CULL_FACE_WRITE);
	
	
	
	pa.setCullFace(pa.CULL_NONE);
	pa.setBackFaceNormalFlip(true);
	app.setPolygonAttributes(pa);

	m = new Material(normalc, eColor, normalc, sColor, 100.0f);
	m.setCapability(m.ALLOW_COMPONENT_WRITE);
	m.setLightingEnable(true);
	app.setMaterial(m);
	mypoint.setAppearance(app);

	bg = new BranchGroup();
	bg.setCapability(BranchGroup.ALLOW_DETACH);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
	sg  = new SharedGroup();
	sg.addChild(mypoint);
	bg.addChild(objTrans);
	//bg.compile(); 
	dobjTrans.addChild(bg);
      }
      public void SetTransparency(float dv){
	tattr.setTransparency(dv);
	app.setTransparencyAttributes(tattr);
	mypoint.setAppearance(app);
	
      }
      public void UnsetTransparency(){
	app.setTransparencyAttributes(null);
	mypoint.setAppearance(app);
	
      }
     
      public void setChild(ControlPoint myCP){
	
	Transform3D t1 = new Transform3D();
	t1.setTranslation(new Vector3d(myCP.point.x,myCP.point.y,myCP.point.z));
	TransformGroup mytrans = new TransformGroup(t1);
        mytrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	mytrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	
	Link mylink = new Link(sg);
	
	//mylink.setUserData(new Integer(tarI));
	//System.out.println("myCP.ID = "+myCP.ID);
	mylink.setUserData(new PickInfo(myCP,ccheck));
	
	mytrans.addChild(mylink);
	objTrans.addChild(mytrans);
	//System.out.println("Num = "+objTrans.numChildren());
      }
      
      public void unbind() {
        bg.detach();
      }
      public void bind(){
	ddobjTrans.addChild(bg);
      
      }
           
    }
