import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class ViewShape3D extends Shape3D{

  int numberV=0;
  int numberF=0;
  public Point3d[] verts;
    public Point2f[] texcoord; 
  public Vector3f[] vertNormal;
  TriangleArray tetra;
  Color3f[] pastel;
  double scaler=1.0;
  Vector3d ddnormalv3d = new Vector3d(0.0,0.0,0.0);
  Vector3d v1v3d = new Vector3d(0.0,0.0,0.0);
  Vector3d v2v3d = new Vector3d(0.0,0.0,0.0);
  Point3d tmppoint3d1 = new Point3d(0.0,0.0,0.0);
  Point3d tmppoint3d2 = new Point3d(0.0,0.0,0.0);
  Color3f[] mycolor;
  Color3f[] mycolordark;
    Color3f[] mycolordark2;
   
  boolean pastelnormal=true;
  int type=0;
  
  public ViewShape3D(int id){
    type = id;
    this.setCapability(Shape3D.ALLOW_PICKABLE_READ);
    this.setCapability(Shape3D.ALLOW_PICKABLE_WRITE); 
  }
 
  
  public void reNew(int dv,int df,double dcaler){
    numberV = dv;
    numberF = df;
    scaler = dcaler;
    MemoryAllocation();
  }
  public void setbipolarColor(double[] color,int[][] Face){
    int i,j;
    float dummyv=0.0f;
    for(i=0;i<numberF;i++){
       for(j=0;j<3;j++){
	 dummyv = ((float)(color[Face[i][j]]));
	 pastel[(3*i+j)].x = biR(dummyv);
	 pastel[(3*i+j)].y = biG(dummyv);
	 pastel[(3*i+j)].z = biB(dummyv);
       }
    }
  }
    public void setPastelColor(double[] color,int[][] Face){
    int i,j;
    float dummyv=0.0f;
    for(i=0;i<numberF;i++){
       for(j=0;j<3;j++){
	 dummyv = ((float)(color[Face[i][j]]));
	 pastel[(3*i+j)].x = paR(dummyv);
	 pastel[(3*i+j)].y = paG(dummyv);
	 pastel[(3*i+j)].z = paB(dummyv);
       }
    }
  }
public void setPastelColorBi(double[] color,int[][] Face){
    int i,j;
    float dummyv=0.0f;
    for(i=0;i<numberF;i++){
       for(j=0;j<3;j++){
	 dummyv = ((float)(color[Face[i][j]]));
	 pastel[(3*i+j)].x = rbiR(dummyv);
	 pastel[(3*i+j)].y = rbiG(dummyv);
	 pastel[(3*i+j)].z = rbiB(dummyv);
       }
    }
  }
    public void setTexture(boolean dv){
    pastelnormal = dv;
    if(dv){
      
      //tetra.setColors(0,mycoloxr);
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS|TriangleArray.TEXTURE_COORDINATE_2);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ);
      tetra.setCapability(tetra.ALLOW_TEXCOORD_WRITE);
      tetra.setCapability(tetra.ALLOW_TEXCOORD_READ);
      tetra.setTextureCoordinates(0,texcoord);
    }else{
	tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
				  TriangleArray.NORMALS | 
				  TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      tetra.setColors(0,mycolor);
    }
    
    tetra.setCoordinates(0,verts);
    tetra.setNormals(0,vertNormal);
    this.setGeometry(tetra); 
  }
    public void setDark(){
	tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ);
      
      
      tetra.setColors(0,mycolordark);
      tetra.setCoordinates(0,verts);
      tetra.setNormals(0,vertNormal);
      this.setGeometry(tetra); 
    }
    public void setDark3(){
	tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ);
      
      
      tetra.setColors(0,mycolordark2);
      tetra.setCoordinates(0,verts);
      tetra.setNormals(0,vertNormal);
      this.setGeometry(tetra); 
    }
    
    
    public void setDark2(){
	tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ);
      
      
      tetra.setColors(0,mycolor);
      tetra.setCoordinates(0,verts);
      tetra.setNormals(0,vertNormal);
      this.setGeometry(tetra); 
    }
  public void setColor(boolean dv){
    pastelnormal = dv;
    if(dv){
      
      //tetra.setColors(0,mycolor);
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ);
      
      
      tetra.setColors(0,mycolor);
      //System.out.println("AAAAAAAAAAAAA");
    }else{
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      
      
      tetra.setColors(0,pastel); 
    }
    tetra.setCoordinates(0,verts);
    tetra.setNormals(0,vertNormal);
    this.setGeometry(tetra); 
  }
   
  private void MemoryAllocation(){
    tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
    tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS);
    mycolor = new Color3f[(numberF*3)];
    mycolordark  = new Color3f[(numberF*3)];
    mycolordark2  = new Color3f[(numberF*3)];
    
    pastel = new Color3f[(numberF*3)];  
    verts = new Point3d[(numberF*3)];
    texcoord = new Point2f[(numberF*3)];
    vertNormal = new Vector3f[(numberF*3)];
    int i=0;
    int j=0;
    for(i=0;i<numberF;i++){
      for(j=0;j<3;j++){
	vertNormal[(3*i+j)] = new Vector3f(0.0f,0.0f,0.0f);
	mycolordark[(3*i+j)] = new Color3f(0.9f,0.9f,0.9f);
	mycolordark2[(3*i+j)] = new Color3f(0.7f,0.7f,0.7f);
	
	if(type==1){
	  mycolor[(3*i+j)] = new Color3f(0.2000f,0.6300f,0.0f);
	}else if(type==4){
	  mycolor[(3*i+j)] = new Color3f(0.200f,0.6300f,0.0f);
	}else if(type==5){
	 
	    mycolor[(3*i+j)] = new Color3f(0.5625f,0.1875f,0.0f);
	}else if(type==6){
	  mycolor[(3*i+j)] = new Color3f(0.2000f,0.300f,1.0f);
	  
	}else if(type==7){
	  mycolor[(3*i+j)] = new Color3f(0.15f,0.15f,0.15f);
	  
	}else if(type==-15){
	    mycolor[(3*i+j)] = new Color3f(0.95f,0.95f,0.95f);
	}else if(type==-16){
	    mycolor[(3*i+j)] = new Color3f(0.2000f,0.6300f,0.7900f);
	}else{
	  mycolor[(3*i+j)] = new Color3f(0.2000f,0.6300f,0.7900f);
	}
	verts[(3*i+j)] = new Point3d(0.0,0.0,0.0);
	pastel[(3*i+j)]  = new Color3f(0.0f,0.0f,1.0f);
	texcoord[(3*i+j)] = new Point2f(0.0f,0.0f);
      }
    }
  }
  
  public void MakeArrayDataAFTER(){
    tetra.setCoordinates(0,verts);
     if(pastelnormal){
       //tetra.setColors(0,mycolor);
        tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 

      
      tetra.setColors(0,mycolor);
      //System.out.println("BBBBBBBBBBBBBBBBBB");
    }else{
       tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 

      
      tetra.setColors(0,pastel); 
    } 
    tetra.setNormals(0,vertNormal); tetra.setCoordinates(0,verts);
    this.setGeometry(tetra);
  }
  public void MakeArrayData(){
    if(pastelnormal){
      //tetra.setColors(0,mycolor);
       tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 

      
      //System.out.println("CCCCCCCCCCCCCCCCC");
      tetra.setColors(0,mycolor);
      
    }else{
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 

      
      
      tetra.setColors(0,pastel); 
    }
 
    tetra.setCoordinates(0,verts);
    tetra.setNormals(0,vertNormal);
    this.setGeometry(tetra); 
 
  }

  public void MakeFace(int i,int di,int dj,int dk,Point3d[] point){
    int[] Face = new int[3];
    Face[0] = di;
    Face[1] = dj;
    Face[2] = dk;
    v1v3d.x = ((point[Face[0]]).x - (point[Face[1]]).x);
    v1v3d.y = ((point[Face[0]]).y - (point[Face[1]]).y);
    v1v3d.z = ((point[Face[0]]).z - (point[Face[1]]).z);
    v2v3d.x = ((point[Face[0]]).x - (point[Face[2]]).x);
    v2v3d.y = ((point[Face[0]]).y - (point[Face[2]]).y);
    v2v3d.z = ((point[Face[0]]).z - (point[Face[2]]).z);
    ddnormalv3d.cross(v1v3d, v2v3d);
    ddnormalv3d.normalize();
    int j=0;
 
    for(j=0;j<3;j++){
      verts[(3*i+j)].x = point[Face[j]].x*scaler;
      verts[(3*i+j)].y = point[Face[j]].y*scaler;
      verts[(3*i+j)].z = point[Face[j]].z*scaler;
      
      vertNormal[(3*i+j)].x = ((float)(ddnormalv3d.x));
      vertNormal[(3*i+j)].y = ((float)(ddnormalv3d.y));
      vertNormal[(3*i+j)].z = ((float)(ddnormalv3d.z));
    }
    
  }
    public void MakeFaceN(int i,int di,int dj,int dk,Point3d[] point,Point3d[] normal){
    int[] Face = new int[3];
    Face[0] = di;
    Face[1] = dj;
    Face[2] = dk;
    int j=0;
 
    for(j=0;j<3;j++){
      verts[(3*i+j)].x = point[Face[j]].x*scaler;
      verts[(3*i+j)].y = point[Face[j]].y*scaler;
      verts[(3*i+j)].z = point[Face[j]].z*scaler;
      
      vertNormal[(3*i+j)].x = ((float)(normal[Face[j]].x));
      vertNormal[(3*i+j)].y = ((float)(normal[Face[j]].y));
      vertNormal[(3*i+j)].z = ((float)(normal[Face[j]].z));
    }
    
  }
    
    
    public void MakeFace(int i,int di,int dj,int dk,Point3d[] point,Point3d[] normal){
	int[] Face = new int[3];
	Face[0] = di;
	Face[1] = dj;
	Face[2] = dk;
	double d0x,d0y,d0z,d1x,d1y,d1z,d2x,d2y,d2z;
	d0x = (point[Face[0]]).x - 0.15*normal[Face[0]].x;
	d0y = (point[Face[0]]).y - 0.15*normal[Face[0]].y;
	d0z = (point[Face[0]]).z - 0.15*normal[Face[0]].z;
	d1x = (point[Face[1]]).x - 0.15*normal[Face[1]].x;
	d1y = (point[Face[1]]).y - 0.15*normal[Face[1]].y;
	d1z = (point[Face[1]]).z - 0.15*normal[Face[1]].z;
	d2x = (point[Face[2]]).x - 0.15*normal[Face[2]].x;
	d2y = (point[Face[2]]).y - 0.15*normal[Face[2]].y;
	d2z = (point[Face[2]]).z - 0.15*normal[Face[2]].z;
	
	v1v3d.x = (d0x - d1x)*scaler;
	v1v3d.y = (d0y - d1y)*scaler;
	v1v3d.z = (d0z - d1z)*scaler;
	v2v3d.x = (d0x - d2x)*scaler;
	v2v3d.y = (d0y - d2y)*scaler;
	v2v3d.z = (d0z - d2z)*scaler;
	ddnormalv3d.cross(v1v3d, v2v3d);
	ddnormalv3d.normalize();
	int j=0;
	for(j=0;j<3;j++){
	    
	    
	    
	    
	    vertNormal[(3*i+j)].x = ((float)(ddnormalv3d.x));
	    vertNormal[(3*i+j)].y = ((float)(ddnormalv3d.y));
	    vertNormal[(3*i+j)].z = ((float)(ddnormalv3d.z));
	}
	
	
  j=0;
  verts[(3*i+j)].x = d0x*scaler;
  verts[(3*i+j)].y = d0y*scaler;
  verts[(3*i+j)].z = d0z*scaler;
  j=1;
  verts[(3*i+j)].x = d1x*scaler;
  verts[(3*i+j)].y = d1y*scaler;
  verts[(3*i+j)].z = d1z*scaler;
  j=2;
  verts[(3*i+j)].x = d2x*scaler;
  verts[(3*i+j)].y = d2y*scaler;
  verts[(3*i+j)].z = d2z*scaler;
  
    
  }
  private float paG(float dv){
    if(dv >0.5){
      return ((float)(-2.0*dv + 2.0));
    }else{
    return 1.0f;
    }
  }
    public void setTexCoord(int i,int di,int dj,int dk,Point3d[] in,int imgNs){
	int[] Face = new int[3];
	Face[0] = di;
	Face[1] = dj;
	Face[2] = dk;
	 int j=0;
 	 for(j=0;j<3;j++){
	     texcoord[(3*i+j)].x = ((float)((in[Face[j]].x/((double)(imgNs)))));
	     texcoord[(3*i+j)].y = ((float)((in[Face[j]].y/((double)(imgNs)))));
	 }
    }
    private float paR(float dv){
    if(dv <0.5){
      return ((float)(2.0*dv));
  }else{
    return 1.0f;
  }
  }
  private float paB(float dv){
    if(dv <0.5){
      return ((float)(-2.0*dv + 1.0));
    }else{
      return ((float)(2.0*dv - 1.0));
    }
  }
  private float rbiR(float dv){
    if(dv <0.5)return 0.0f;
    return ((float)(2.0*dv-1.0));
  
  }
  private float rbiG(float dv){
    
    return ((float)(-Math.sin(Math.acos(2.0*dv-1.0))+1.0));
    
  }
  private float rbiB(float dv){
    if(dv>=0.5)return 0.0f;
    return ((float)(-2.0*dv+1.0));
    
  }
  
  
  

  private float biR(float dv){
	if(dv <0.5){
	    return 1.0f;
	
	}else if(0.5<=dv&&0.625>dv){
	    return ((float)(3.0-dv/0.25));
	}else{
	    return 0.5f;
	}
    }
    private float biB(float dv){
	if(dv <0.125){
	    return 1.0f;
	}else if(0.125<=dv&&0.25>dv){
	    return ((float)(2.0-dv/0.125));
	}else if(0.25<=dv&&0.375>dv){
	    return 0.0f;
	}else if(0.375<=dv&&0.5>dv){
	    return 0.0f;
	}else if(0.5<=dv&&0.625>dv){
	    return 0.0f;
	}else if(0.625<=dv&&0.75>dv){
	    return ((float)(-5.0+dv/0.125));
	}else if(0.75<=dv&&0.875>dv){
	    return 1.0f;
	}else{
	    //return ((float)(8.0-dv/0.125));
	    return 1.0f;
	    
	}
    }
    private float biG(float dv){
	if(dv <0.125){
	    return ((float)(1.0-dv/0.125));
	}else if(0.125<=dv&&0.25>dv){
	    return 0.0f;
	}else if(0.25<=dv&&0.375>dv){
	    return 0.0f;
	}else if(0.375<=dv&&0.5>dv){
	    return ((float)(-3.0+dv/0.125));
	}else if(0.5<=dv&&0.625>dv){
	    return 1.0f;
	}else if(0.625<=dv&&0.875>dv){
	    return 1.0f;
	
	}else{
	    return ((float)(4.5-dv/(0.25)));
	}
    }
    
}
