
class Polynomial{
 public:
  int N;
 
  Point3d **point;//u,v,fi
  double *w;
  double **v;
  double **a;
  double *dkk;
  double *ab;
  SvdSolve *mysvd;
  int sN;
  
  Polynomial(int dN){
    N = dN;
    mysvd = new SvdSolve();
    point = new Point3d* [N];
    int i;
    
    if(degree==2){
      sN = 8;
    }else if(degree==3){
      sN = 8;
    }
    
    
    ab = new double[sN];
    w = new double[sN];
    v = new double* [sN];
    for(i=0;i<sN;i++)v[i] = new double[sN];

    a = new double* [3*N+1];
    for(j=0;j<3*N+1;j++)a[j] = new double[sN];
    dkk = new double[3*N+1];
    dkk = new double[sN];
    a = new double* [sN];
    for(i=0;i<sN;i++){
      v[i] = new double[sN];
      a[i] = new double[sN];
    }
  
    for(i=0;i<N;i++)point[i] = new Point3d(0.0,0.0,0.0);
  }
  void Polynomial::setPoint(int i,double dx,double dy,double dz){
    point[i]->x = dx;
    point[i]->y = dy;
    point[i]->z = dz;
    
  }
  void Polynomial::Fitting(){
    int i,j; double dx,dy,dist;
    for(i=0;i<N;i++){
      dkk[i+1] = point[i]->z;
    }
    double wmax,wmin;
    dkk[N+1]=0.0;
    dkk[N+2]=0.0;
    dkk[N+3]=0.0;
    
    for(i=0;i<N;i++){
      for(j=0;j<N;j++){
	dx = point[i]->x-point[j]->x;
	dy = point[i]->y-point[j]->y;
	dist = sqrt((dx*dx+dy*dy));
	a[i+1][j+1] = Phi(dist);
	//a[i+1][j+1] = Phi2(dist,sig);
	
      }
      a[i+1][N+1] = 1.0;
      a[i+1][N+2] = point[i]->x;
      a[i+1][N+3] = point[i]->y;
    }
    for(j=0;j<N;j++){
      a[N+1][j+1] = 1.0;
      a[N+2][j+1] = point[j]->x;
      a[N+3][j+1] = point[j]->y;
    }
    for(i=1;i<=3;i++)
      for(j=1;j<=3;j++)
	a[N+i][N+j] = 0.0;
    mysvd->svdcmp(a,(N+3),(N+3),w,v);
    wmax=0.0;
    for(j=1;j<=(N+3);j++){
      if(w[j]>wmax)wmax=w[j];
    }
    wmin = wmax*0.000001;
    for(j=1;j<=N+3;j++)if(w[j]<wmin)w[j]=0.0;
    mysvd->svbksb(a,w,v,(N+3),(N+3),dkk,ab);
    
    
  }
  virtual ~Polynomial(){
    int i;
    delete mysvd;
    for(i=0;i<N;i++)delete point[i];
    delete [] ab;
    delete [] w;
    delete [] dkk;
    for(i=0;i<sN;i++){
      delete [] v[i];
      delete [] a[i];
    }
    delete [] a;
    delete [] v;
    delete [] point;
    
  }
  double Polynomial::DEva(double du,double dv){
    int i;
    double dsum=0.0;
    double dx,dy,dist;
    for(i=0;i<N;i++){
      dx = point[i]->x-du;
      dy = point[i]->y-dv;
      dist = sqrt(dx*dx+dy*dy);
      dsum += ab[i+1]*Phi(dist);
    }
   
    return (p(du,dv)+dsum);
  }
  
  
 private:
   Polynomial(const Polynomial& rhs);
  const Polynomial &operator=(const Polynomial& rhs);


};
#undef p
#undef Phi
#undef Phi2
