import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.geometry.*;
    public class ObjectSphereTransform {
      public TransformGroup objTrans;
      public TransformGroup ddobjTrans;
      
      private BranchGroup bg=null;
      Appearance app;
      Material m;Vector3d mytransition = new Vector3d(0.0,0.0,0.0);
      TransparencyAttributes tattr;
      TransformGroup mytrans;
      PolygonAttributes pa;
      Color3f eColor = new Color3f(0.0f, 0.0f, 0.0f);
      Color3f sColor = new Color3f(1.0f, 1.0f, 1.0f);
      Color3f normalc;
      Sphere mypoint;   
      int ccheck=1;
      /* public void setPosition(Point3d dv){
	Transform3D trns = new Transform3D();
	trns.setTranslation(new Vector3d(dv.x,dv.y,dv.z));
	objTrans.setTransform(trns);
	}*/
      public void setPosition(int targetI,Point3d dv){
	Transform3D trns = new Transform3D();
	trns.setTranslation(new Vector3d(dv.x,dv.y,dv.z));
	
	((TransformGroup)(objTrans.getChild(targetI))).setTransform(trns);
	//System.out.println(+dv.x+" "+dv.y+" "+dv.z);
      }
      public void setRadius(int targetI,double dr,Point3d dv,double scale){
	
	Transform3D trns = new Transform3D();
	trns.setScale(dr);
	trns.setTranslation(new Vector3d(dv.x*scale,dv.y*scale,dv.z*scale));
	((TransformGroup)(objTrans.getChild(targetI))).setTransform(trns);
      }

      
      
	public void changeSR(double dr,Point3d dv){
	
	Transform3D trns = new Transform3D();
	trns.setScale(dr);
	trns.setTranslation(new Vector3d(dv.x,dv.y,dv.z));
	((TransformGroup)(objTrans.getChild(0))).setTransform(trns);
      }


      public ObjectSphereTransform(float Sphereradius,
				 TransformGroup dobjTrans,
				 float dR,float dG,float dB){
	
	ddobjTrans = dobjTrans;
	/* mypoint = new Sphere(1.0f,Sphere.GENERATE_NORMALS|Sphere.ENABLE_GEOMETRY_PICKING,20);
	mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
	mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	mypoint.setPickable(false);*/
	
	normalc = new Color3f(dR,dG,dB);
	
        objTrans = new TransformGroup();
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
	objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
	app = new Appearance();
	app.setCapability(app.ALLOW_POINT_ATTRIBUTES_WRITE);
	app.setCapability(app.ALLOW_POLYGON_ATTRIBUTES_WRITE);
	app.setCapability(app.ALLOW_MATERIAL_WRITE);
	app.setCapability(app.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
	
	tattr = new TransparencyAttributes(TransparencyAttributes.BLENDED,0.625f);
	tattr.setCapability(TransparencyAttributes.ALLOW_VALUE_READ); 
	tattr.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
	tattr.setTransparencyMode(TransparencyAttributes.BLENDED);
	
	app.setTransparencyAttributes(tattr);
	//app.setTransparencyAttributes(null);
	
	pa = new PolygonAttributes();
	pa.setCapability(pa.ALLOW_MODE_WRITE);
	pa.setCapability(pa.ALLOW_NORMAL_FLIP_WRITE);
	pa.setCapability(pa.ALLOW_CULL_FACE_WRITE);
	
	
	
	
	pa.setBackFaceNormalFlip(false);
	pa.setCullFace(pa.CULL_BACK);
	app.setPolygonAttributes(pa);

	m = new Material(normalc, eColor, normalc, sColor, 100.0f);
	m.setCapability(m.ALLOW_COMPONENT_WRITE);
	m.setLightingEnable(true);
	app.setMaterial(m);
	//mypoint.setAppearance(app);

	bg = new BranchGroup();
	bg.setCapability(BranchGroup.ALLOW_DETACH);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
	bg.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
	/*
	TransformGroup mytrans2 = new TransformGroup();
        
	mytrans2.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	mytrans2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	mytrans2.addChild(mypoint);
	
	objTrans.addChild(mytrans2);
	*/
	bg.addChild(objTrans);
	dobjTrans.addChild(bg);
      }
      public void SetTransparency(float dv){
	tattr.setTransparency(dv);
	app.setTransparencyAttributes(tattr);
	mypoint.setAppearance(app);
	
      }
      public void UnsetTransparency(){
	app.setTransparencyAttributes(null);
	mypoint.setAppearance(app);
      }
     
      public void setChild(ControlPoint myCP,double CPR){
	
	Transform3D t1 = new Transform3D();
	t1.setTranslation(new Vector3d(myCP.point.x,myCP.point.y,myCP.point.z));
	TransformGroup mytrans = new TransformGroup(t1);
        mytrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	mytrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	
	if(CPR==0.0){
	  mypoint = new Sphere(1.0f,Sphere.GENERATE_NORMALS|Sphere.ENABLE_GEOMETRY_PICKING,20);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	  mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
	  mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	}else{
	  mypoint = new Sphere(((float)(CPR)),Sphere.GENERATE_NORMALS|Sphere.ENABLE_GEOMETRY_PICKING,20);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	  mypoint.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	  mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
	  mypoint.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	}
	mypoint.setAppearance(app);
	mypoint.setPickable(false);
	mytrans.addChild(mypoint);
	//BranchGroup mybglo = new BranchGroup();
	//mybglo.addChild(mytrans);
	//objTrans.addChild(mybglo);
	objTrans.addChild(mytrans);
      }
      
      public void unbind() {
        bg.detach();
      }
      public void bind(){
	ddobjTrans.addChild(bg);
      
      }
           
    }
